---
order: 50
---

# Column Type Classes

## Namespace `cheetahGrid.columns.type`

| Class Name                   | Function                         | Others                                       | Related Links                          |
| ---------------------------- | -------------------------------- | -------------------------------------------- | -------------------------------------- |
| `Column`                     | show text                        | same as not specify type                     | ---                                    |
| [`NumberColumn`]             | show number with comma-separated | same as `columnType: 'number'`               | [NumberColumn]                         |
| [`CheckColumn`]              | show checkbox                    | same as `columnType: 'check'`                | - [CheckColumn]<br>- [CheckEditor]     |
| [`MenuColumn`]               | show menu                        | ---                                          | - [MenuColumn]<br>- [InlineMenuEditor] |
| [`ButtonColumn`]             | show button                      | `columnType: 'button'` has same the function | - [ButtonColumn]<br>- [ButtonAction]   |
| [`ImageColumn`]              | show image                       | same as `columnType: 'image'`                | [ImageColumn]                          |
| [`PercentCompleteBarColumn`] | show percent complete bar        | ---                                          | [PercentCompleteBarColumn]             |
| [`IconColumn`]               | show icon only                   | ---                                          | [IconColumn]                           |
| [`MultilineTextColumn`]      | show multiline text              | same as `columnType: 'multilinetext'`        | [MultilineTextColumn]                  |
| [`BranchGraphColumn`]        | show branch graph                | ---                                          | [BranchGraphColumn]                    |
| [`RadioColumn`]              | show radio button                | same as `columnType: 'radio'`                | - [RadioColumn]<br>- [RadioEditor]     |

[`numbercolumn`]: ./NumberColumn.md
[`checkcolumn`]: ./CheckColumn.md
[`menucolumn`]: ./MenuColumn.md
[`buttoncolumn`]: ./ButtonColumn.md
[`imagecolumn`]: ./ImageColumn.md
[`percentcompletebarcolumn`]: ./PercentCompleteBarColumn.md
[`iconcolumn`]: ./IconColumn.md
[`multilinetextcolumn`]: ./MultilineTextColumn.md
[`branchgraphcolumn`]: ./BranchGraphColumn.md
[`radiocolumn`]: ./RadioColumn.md
[numbercolumn]: ./NumberColumn.md
[checkcolumn]: ./CheckColumn.md
[checkeditor]: ../column_actions/CheckEditor.md
[menucolumn]: ./MenuColumn.md
[inlinemenueditor]: ../column_actions/InlineMenuEditor.md
[buttoncolumn]: ./ButtonColumn.md
[buttonaction]: ../column_actions/ButtonAction.md
[imagecolumn]: ./ImageColumn.md
[percentcompletebarcolumn]: ./PercentCompleteBarColumn.md
[iconcolumn]: ./IconColumn.md
[multilinetextcolumn]: ./MultilineTextColumn.md
[branchgraphcolumn]: ./BranchGraphColumn.md
[radiocolumn]: ./RadioColumn.md
[radioeditor]: ../column_actions/RadioEditor.md
